﻿
function EditInfo(name, editNum, seperator, wordPerEdit, regex, IsAcceptKey, IsValidField)
{
    this.name = name;
    this.editNum = editNum;
    this.seperator = seperator;
    this.wordPerEdit = wordPerEdit;
    this.regex = regex;
    this.IsAcceptKey = IsAcceptKey;
    this.IsValidField = IsValidField;
}

//0:mac, 1:ipv4
function MultiEdit(id,editType)
{
    this.id = id;
    this.editType = editType;
    this.editInfo = MultiEdit.EditInfo[editType];
    this.editNum = this.editInfo.editNum;
    this.seperator = this.editInfo.seperator;
    this.onChange=new Function();
    this.onEnterKey=new Function();
    this.disabled=false;
    MultiEdit.all[id]=this;
}
MultiEdit.all={};
MultiEdit.EnabledClassName="multiEditInput";//启用时样式
MultiEdit.DisabledClassName="multiEditInputDisabled";// 禁用时样式
MultiEdit.EditInfo = new Array(
    new EditInfo("mac", 6, "-", 2, /^[0-9a-f]{2}(-[0-9a-f]{2}){5}$/i, IsMacAcceptKey, IsMacValidField),
    new EditInfo("ipv4", 4, ".", 3, /^[\d]{1,3}(\.[\d]{1,3}){3}$/, IsIpAcceptKey, IsIpValidField)
);

MultiEdit.prototype=
{
/**
* 激活编辑框
* @param {number} index 1...editNum　指定激活的位置
*/
    focus:function(index)
    {
        if(!index)
        index=1;
        document.getElementById(this.id+"_"+index).focus();
    },
    setEnable:function(bEnable)
    {
        var b=!bEnable;
        this.disabled=!bEnable;
        var boxes=document.getElementById(this.id).getElementsByTagName("input");
        for(var i=0;i<boxes.length;i++)
        {
            boxes[i].readOnly=b;
        }
        document.getElementById(this.id).className=bEnable?MultiEdit.EnabledClassName:MultiEdit.DisabledClassName;
    },
    toString:function()
    {
        var str='<span  id="'+this.id+'" class="' + MultiEdit.EnabledClassName + '"  >';
        for(i = 1; i <= this.editNum; i++)
        {
            str += '<input style = "width:50px" onkeypress="MultiEdit.evt.keypress(this,event)" onkeydown="MultiEdit.evt.keydown(this,event)" onfocus="MultiEdit.evt.focus(this,event)" onpaste="MultiEdit.evt.change(this,event);" oninput="MultiEdit.evt.change(this,event);" onchange="MultiEdit.evt.change(this,event),g_bChange = true;"  type="text" size=3  id="'+this.id+'_'+i+'" maxlength='+this.editInfo.wordPerEdit+'/>';
            if(i < this.editNum)
            {
                str+=this.seperator;
            }
        }
        //padding-left:15px;
        str += '</span>';
        return str;
    },
    getValue:function()
    {
        var arrValue=new Array(this.editNum);
        for(var i = 1; i <= this.editNum; i++)
        {
            arrValue[i-1] = document.getElementById(this.id+"_"+i).value;
        }
        return arrValue.join(this.seperator);
    },
    setValue:function(value)
    {
        if(value.search(this.editInfo.regex) != -1)
        {
            value = value.split(this.seperator);
            for(var i = 1; i <= this.editNum; i++)
            {
                document.getElementById(this.id+"_"+i).value = "0000".substr(0, this.editInfo.wordPerEdit-value[i-1].length)+value[i-1];
            }
        }
        else
        {
            for(var i = 1; i <= this.editNum; i++)
            {
                document.getElementById(this.id+"_"+i).value = "0000".substr(0, this.editInfo.wordPerEdit);
            }
        }
    }
}
MultiEdit.evt=
{
    focus:function(obj,evt)
    {
        obj.select();
    },
    change:function(obj,evt)
    {
        var EditId = obj.id.replace(/_\d$/,"");
        if( MultiEdit.all[EditId].editInfo.IsValidField(obj.value) )
        {
            obj.value="0000".substr(0, MultiEdit.all[EditId].editInfo.wordPerEdit-obj.value.length)+obj.value;
        }
        else
        {
            obj.value="0000".substr(0, MultiEdit.all[EditId].editInfo.wordPerEdit);
        }
        MultiEdit.all[ EditId ].onChange();
        g_bNetworkPassTest = false;
    },
    keypress:function(obj,evt)
    {
        var id=obj.id;
        /(.*)_(\d)$/.test(id);
        var index=RegExp.$2;
        var Ip_id=RegExp.$1;
        var key=evt.charCode||evt.keyCode;
        var pos=MultiEdit.evt.getSelection(obj);
        var value=obj.value;
        var c=String.fromCharCode(key);
        if(MultiEdit.all[Ip_id].editInfo.IsAcceptKey(key))
        {
            value=""+value.substring(0,pos.start) + c + value.substring(pos.end,value.length);
            if(MultiEdit.all[Ip_id].editInfo.IsValidField(value))
            {
                if(value.length>=MultiEdit.all[Ip_id].editInfo.wordPerEdit)
                {
                    if(parseInt(index,10)<MultiEdit.all[Ip_id].editNum)
                    {
                        id=id.replace(/(\d)$/,parseInt(index,10)+1 );
                        setTimeout("document.getElementById('"+id+"').focus();"+"document.getElementById('"+id+"').select();",200);
                    }
                }
                setTimeout("MultiEdit.all['"+Ip_id+"'].onChange()",0);
                return true;
            }
            else
            {
                if(evt.preventDefault)
                evt.preventDefault();
                evt.returnValue=false;
                return false;
            }
        }
        else
        {
            if(evt.preventDefault)
            evt.preventDefault();
            evt.returnValue=false;
        }
    },
    keydown:function(obj,evt)
    {
        var key=evt.charCode||evt.keyCode;
        var pos=MultiEdit.evt.getSelection(obj);
        var value=obj.value;
        var c=String.fromCharCode(key);
        var id=obj.id;
        /^(.*)_(\d)$/.test(id);
        var index=RegExp.$2;
        var Ip_id=RegExp.$1;
        switch(key)
        {
            case 110://.小键盘
            case 190://.主键盘
            if(index<MultiEdit.all[Ip_id].editNum)
            {
                id=id.replace(/(\d)$/,parseInt(index,10)+1 );
                document.getElementById(id).focus();
                document.getElementById(id).select();
            }
            break;
            case 8://backspace
            if(pos.start>0)
            return;
            case 38://up
            case 37://left
            if(pos.end==0 && index>MultiEdit.all[Ip_id].editNum)
            {
                id=id.replace(/(\d)$/,parseInt(index,10)-1 );
                document.getElementById(id).focus();
                document.getElementById(id).select();
            }
            break;
            case 39://right
            case 40://down
            if(pos.start==value.length && index<MultiEdit.all[Ip_id].editNum)
            {
                id=id.replace(/(\d)$/,parseInt(index,10)+1 );
                document.getElementById(id).focus();
                document.getElementById(id).select();
            }
            break;
        }
    },
    //获取选区位置
    getSelection:function(oInput)
    {
        var T=this;
        if(oInput.createTextRange)
        {
            var s=document.selection.createRange().duplicate();
            s.moveStart("character",-oInput.value.length);
            var p1=s.text.length;
            var s=document.selection.createRange().duplicate();
            s.moveEnd("character",oInput.value.length);
            var p2=oInput.value.lastIndexOf(s.text);
            if(s.text=="")
            {
                p2=oInput.value.length;
            }
            return {start:p2,end:p1};
        }
        else 
        {
            return {start:oInput.selectionStart,end:oInput.selectionEnd};
        }
    }
}

function IsMacAcceptKey(key)
{
    if((key >= 48 && key <= 57) || (key >= 65 && key <= 70) || (key >= 97 && key <= 102))
    {
        return true;
    }
    return false;
}

function IsIpAcceptKey(key)
{
    if(key >= 48 && key <= 57)
    {
        return true;
    }
    return false;
}

function IsMacValidField(value)
{
    return true;
}

function IsIpValidField(value)
{
    var num = parseInt(value,10);
    if(num >= 0 && value <= 255)
    {
        return true;
    }
    return false;
}